changeset 201:229916c1f1b0

added a test for merge (fails actually)
author Abderrahim Kitouni <a.kitouni@gmail.com>
date Sun, 28 Jun 2009 22:00:46 +0100
parents dfed3bd84184
children 1593538448b1
files tests/test-merge tests/test-merge.out
diffstat 2 files changed, 140 insertions(+), 0 deletions(-) [+]
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/test-merge	Sun Jun 28 22:00:46 2009 +0100
@@ -0,0 +1,77 @@
+#!/bin/sh
+
+# Fails for some reason, need to investigate
+# "$TESTDIR/hghave" git || exit 80
+
+# bail early if the user is already running git-daemon
+echo hi | nc localhost 9418 2>/dev/null && exit 80
+
+echo "[extensions]" >> $HGRCPATH
+echo "hggit=$(echo $(dirname $(dirname $0)))" >> $HGRCPATH
+echo 'hgext.graphlog =' >> $HGRCPATH
+echo 'hgext.bookmarks =' >> $HGRCPATH
+
+GIT_AUTHOR_NAME='test'; export GIT_AUTHOR_NAME
+GIT_AUTHOR_EMAIL='test@example.org'; export GIT_AUTHOR_EMAIL
+GIT_AUTHOR_DATE="2007-01-01 00:00:00 +0000"; export GIT_AUTHOR_DATE
+GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"; export GIT_COMMITTER_NAME
+GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"; export GIT_COMMITTER_EMAIL
+GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"; export GIT_COMMITTER_DATE
+
+count=10
+commit()
+{
+    GIT_AUTHOR_DATE="2007-01-01 00:00:$count +0000"
+    GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
+    git commit "$@" >/dev/null 2>/dev/null || echo "git commit error"
+    count=`expr $count + 1`
+}
+
+mkdir gitrepo
+cd gitrepo
+git init | python -c "import sys; print sys.stdin.read().replace('$(dirname $(pwd))/', '')"
+echo alpha > alpha
+git add alpha
+commit -m 'add alpha'
+
+git checkout -b beta
+echo beta > beta
+git add beta
+commit -m 'add beta'
+
+git checkout master
+echo gamma > gamma
+git add gamma
+commit -m 'add gamma'
+
+# clean merge
+git merge beta
+
+cd ..
+mkdir gitrepo2
+cd gitrepo2
+git init | python -c "import sys; print sys.stdin.read().replace('$(dirname $(pwd))/', '')"
+
+# dulwich does not presently support local git repos, workaround
+cd ..
+git daemon --base-path="$(pwd)"\
+ --listen=localhost\
+ --export-all \
+ --pid-file=gitdaemon.pid \
+ --detach --reuseaddr \
+ --enable=receive-pack
+
+hg clone git://localhost/gitrepo hgrepo
+cd hgrepo
+
+echo % clear the cache to be sure it is regenerated correctly
+hg gclear
+hg push git://localhost/gitrepo2
+
+cd ..
+cd gitrepo2
+git log master
+git log beta
+
+cd ..
+kill `cat gitdaemon.pid`
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/test-merge.out	Sun Jun 28 22:00:46 2009 +0100
@@ -0,0 +1,63 @@
+Initialized empty Git repository in gitrepo/.git/
+
+Switched to a new branch "beta"
+Switched to branch "master"
+Merge made by recursive.
+ beta |    1 +
+ 1 files changed, 1 insertions(+), 0 deletions(-)
+ create mode 100644 beta
+Initialized empty Git repository in gitrepo2/.git/
+
+fetching from : git://localhost/gitrepo
+importing Hg objects into Git
+Counting objects: 11, done.
+Compressing objects:  14% (1/7)   
Compressing objects:  28% (2/7)   
Compressing objects:  42% (3/7)   
Compressing objects:  57% (4/7)   
Compressing objects:  71% (5/7)   
Compressing objects:  85% (6/7)   
Compressing objects: 100% (7/7)   
Compressing objects: 100% (7/7), done.
+Total 11 (delta 3), reused 0 (delta 0)
+importing Git objects into Hg
+at: 0/4
+updating working directory
+3 files updated, 0 files merged, 0 files removed, 0 files unresolved
+% clear the cache to be sure it is regenerated correctly
+clearing out the git cache data
+pushing to git://localhost/gitrepo2
+fetching from : git://localhost/gitrepo2
+importing Hg objects into Git
+at: 0/4
+nothing new on the server
+pushing to : git://localhost/gitrepo2
+creating and sending data
+commit 5806851511aaf3bfe813ae3a86c5027165fa9b96
+Merge: e5023f9... 9497a4e...
+Author: test <test@example.org>
+Date:   Mon Jan 1 00:00:12 2007 +0000
+
+    Merge branch 'beta'
+
+commit e5023f9e5cb24fdcec7b6c127cec45d8888e35a9
+Author: test <test@example.org>
+Date:   Mon Jan 1 00:00:12 2007 +0000
+
+    add gamma
+
+commit 9497a4ee62e16ee641860d7677cdb2589ea15554
+Author: test <test@example.org>
+Date:   Mon Jan 1 00:00:11 2007 +0000
+
+    add beta
+
+commit 7eeab2ea75ec1ac0ff3d500b5b6f8a3447dd7c03
+Author: test <test@example.org>
+Date:   Mon Jan 1 00:00:10 2007 +0000
+
+    add alpha
+commit 9497a4ee62e16ee641860d7677cdb2589ea15554
+Author: test <test@example.org>
+Date:   Mon Jan 1 00:00:11 2007 +0000
+
+    add beta
+
+commit 7eeab2ea75ec1ac0ff3d500b5b6f8a3447dd7c03
+Author: test <test@example.org>
+Date:   Mon Jan 1 00:00:10 2007 +0000
+
+    add alpha